"{ Package: 'stx:goodies/cypress' }"

CypressPatchOperation subclass:#CypressAddition
	instanceVariableNames:'definition'
	classVariableNames:''
	poolDictionaries:''
	category:'Cypress-Definitions'
!

CypressAddition comment:'Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.'
!


!CypressAddition class methodsFor:'instance creation'!

of: aDefinition
	^ self new definition: aDefinition
! !

!CypressAddition methodsFor:'accessing'!

definition

	^definition
!

description
    ^ 'add: ' , self definition printString
! !

!CypressAddition methodsFor:'applying'!

applyTo: aCypressLoader

	aCypressLoader applyAddition: self
! !

!CypressAddition methodsFor:'comparing'!

= aPatchOperation
	^(super = aPatchOperation) and: [self definition = aPatchOperation definition]
! !

!CypressAddition methodsFor:'dependency'!

provisions
	"Answer list of global names defined by this definition"

	^self definition provisions
!

requirements
	"Answer list of global names required by this definition"

	^self definition requirements
! !

!CypressAddition methodsFor:'initialization'!

definition: aDefinition

	definition := aDefinition
! !

!CypressAddition methodsFor:'loading'!

loadClassDefinition

	self definition loadClassDefinition
!

loadMethodDefinition
	self definition loadMethodDefinition
!

postLoadDefinition
	self definition postLoadOver: nil
! !

!CypressAddition methodsFor:'printing'!

printString

	| str |
	str := WriteStream on: String new.
	str 
		nextPutAll: super printString;
		nextPutAll: ' (';
		nextPutAll: self description;
		nextPutAll: ')'.
	^str contents
! !

!CypressAddition class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
