"{ Package: 'stx:goodies/cypress' }"

Object subclass:#CypressDefinition
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Cypress-Definitions'
!

CypressDefinition comment:'Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.'
!


!CypressDefinition methodsFor:'accessing'!

description
	self subclassResponsibility
! !

!CypressDefinition methodsFor:'comparing'!

= aDefinition
	^(aDefinition isKindOf: CypressDefinition) and: [self isRevisionOf: aDefinition]
! !

!CypressDefinition methodsFor:'dependency'!

provisions
	"Answer list of global names defined by this definition"

	^#()
!

requirements
	"Answer list of global names required by this definition"

	^#()
! !

!CypressDefinition methodsFor:'loading'!

actualClass

	self subclassResponsibility
!

loadClassDefinition
	"default is to do nothing"
!

loadMethodDefinition
	"default is to do nothing"
!

postLoad
	"noop"
!

postLoadOver: aDefinition

	self postLoad
!

unloadDefinition

	self subclassResponsibility
! !

!CypressDefinition methodsFor:'testing'!

isRevisionOf: aDefinition
	^ (aDefinition isKindOf: CypressDefinition) and: [aDefinition description = self description]
!

isSameRevisionAs: aDefinition
	^ self = aDefinition
! !

!CypressDefinition methodsFor:'visiting'!

classDefinition: classBlock methodDefinition: methodBlock
	"default is noop"
! !

!CypressDefinition class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
