"{ Package: 'stx:goodies/cypress' }"

Object subclass:#CypressDefinitionIndex
	instanceVariableNames:'definitionMap'
	classVariableNames:''
	poolDictionaries:''
	category:'Cypress-Definitions'
!

CypressDefinitionIndex comment:'Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.'
!


!CypressDefinitionIndex class methodsFor:'instance creation'!

definitions: aCollection
	^ self new addAll: aCollection
! !

!CypressDefinitionIndex methodsFor:'accessing'!

definitionMap
	definitionMap ifNil: [ definitionMap := Dictionary new ].
	^ definitionMap
!

definitions
	^self definitionMap values
! !

!CypressDefinitionIndex methodsFor:'adding'!

add: aDefinition
	^ self definitionMap at: aDefinition description put: aDefinition
!

addAll: aCollection
	aCollection do: [:ea | self add: ea]
! !

!CypressDefinitionIndex methodsFor:'querying'!

definitionLike: aDefinition ifPresent: foundBlock ifAbsent: errorBlock
	| definition |
	definition := self definitionMap at: aDefinition description ifAbsent: [].
	^ definition
		ifNil: errorBlock
		ifNotNil: [foundBlock value: definition]
! !

!CypressDefinitionIndex methodsFor:'removing'!

remove: aDefinition
	self definitionMap removeKey: aDefinition description ifAbsent: []
! !

!CypressDefinitionIndex class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
