"{ Package: 'stx:goodies/cypress' }"

CypressPatchOperation subclass:#CypressModification
	instanceVariableNames:'obsoletion modification'
	classVariableNames:''
	poolDictionaries:''
	category:'Cypress-Definitions'
!

CypressModification comment:'Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.'
!


!CypressModification class methodsFor:'instance creation'!

of: base to: target
	^ self new base: base target: target
! !

!CypressModification methodsFor:'accessing'!

description
    ^ 'modify from: ' , self obsoletion printString , ' to: ' , self modification printString
!

modification

	^modification
!

obsoletion

	^obsoletion
! !

!CypressModification methodsFor:'applying'!

applyTo: aCypressLoader

	aCypressLoader applyModification: self
! !

!CypressModification methodsFor:'dependency'!

provisions
	"Answer list of global names defined by this definition"

	^self modification provisions
!

requirements
	"Answer list of global names required by this definition"

	^self modification requirements
! !

!CypressModification methodsFor:'initialization'!

= aPatchOperation
	^(super = aPatchOperation) and: [self obsoletion = aPatchOperation obsoletion and: [ self modification = aPatchOperation modification]]
!

base: base target: target

	obsoletion := base.
	modification := target.
! !

!CypressModification methodsFor:'loading'!

loadClassDefinition

	self modification loadClassDefinition
!

loadMethodDefinition
	self modification loadMethodDefinition
!

postLoadDefinition
	self modification postLoadOver: self obsoletion
! !

!CypressModification methodsFor:'printing'!

printString

	| str |
	str := WriteStream on: String new.
	str 
		nextPutAll: super printString;
		nextPutAll: ' (';
		nextPutAll: self description;
		nextPutAll: ')'.
	^str contents
! !

!CypressModification class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
