"{ Package: 'stx:goodies/cypress' }"

Object subclass:#CypressPackageDefinition
	instanceVariableNames:'name'
	classVariableNames:''
	poolDictionaries:''
	category:'Cypress-Definitions'
!

CypressPackageDefinition comment:'Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.'
!


!CypressPackageDefinition methodsFor:'accessing'!

name
	^ name
!

name: aString
	name := aString
! !

!CypressPackageDefinition methodsFor:'comparing'!

= other
	^ other species = self species and: [other name sameAs: name]
! !

!CypressPackageDefinition methodsFor:'printing'!

printString
	^super printString, '(', name, ')'
! !

!CypressPackageDefinition methodsFor:'snapshotting'!

snapshot
    | package definitions classMap |
    package := ProjectDefinition definitionClassForPackage: self name createIfAbsent: true.
    definitions := OrderedCollection new.
    package classes
        do: [ :cls | 
            definitions add: cls asCypressClassDefinition.
            (cls methodDictionary values asSortedCollection: [ :a :b | a selector <= b selector ])
                do: [ :method | 
                    (method category at: 1) = $*
                        ifFalse: [ definitions add: method asCypressMethodDefinition ] ].
            (cls class methodDictionary values asSortedCollection: [ :a :b | a selector <= b selector ])
                do: [ :method | 
                    (method category at: 1) = $*
                        ifFalse: [ definitions add: method asCypressMethodDefinition ] ] ].
    classMap := Dictionary new.

    package extensionMethods do:[:mthd|
        (classMap at: mthd mclass theNonMetaclass ifAbsentPut:[SortedCollection sortBlock:[:m1 :m2|m1 category < m2 category]])
            add: mthd asCypressMethodDefinition
    ].

    (Class classesSortedByLoadOrder: classMap keys) do: [ :aClass | definitions addAll: (classMap at: aClass) ].
    ^ CypressSnapshot definitions: definitions

    "Modified: / 30-08-2012 / 14:25:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CypressPackageDefinition class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
