"{ Package: 'stx:goodies/cypress' }"

Object subclass:#CypressPatchOperation
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Cypress-Definitions'
!

CypressPatchOperation comment:'Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.'
!


!CypressPatchOperation methodsFor:'accessing'!

description

	self subclassResponsibility
! !

!CypressPatchOperation methodsFor:'applying'!

applyTo: aCypressLoader

	self subclassResponsibility
! !

!CypressPatchOperation methodsFor:'comparing'!

= aPatchOperation
	^aPatchOperation isKindOf: self class
!

hash
    ^ self description hash
! !

!CypressPatchOperation methodsFor:'dependency'!

provisions
	"Answer list of global names defined by this definition"

	self subclassResponsibility
!

requirements
	"Answer list of global names required by this definition"

	self subclassResponsibility
! !

!CypressPatchOperation methodsFor:'loading'!

loadClassDefinition

	self subclassResponsibility
!

loadMethodDefinition
	self subclassResponsibility
!

postLoadDefinition
	self subclassResponsibility
!

unloadDefinition

	self error: 'inappropriate to send #unloadDefinition to an addition or modification operation'
! !

!CypressPatchOperation class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
