"{ Package: 'stx:goodies/cypress' }"

CypressPatchOperation subclass:#CypressRemoval
	instanceVariableNames:'definition'
	classVariableNames:''
	poolDictionaries:''
	category:'Cypress-Definitions'
!

CypressRemoval comment:'Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.'
!


!CypressRemoval class methodsFor:'instance creation'!

of: aDefinition
	^ self new definition: aDefinition
! !

!CypressRemoval methodsFor:'accessing'!

definition

	^definition
!

description

	^'remove: ', self definition printString
! !

!CypressRemoval methodsFor:'applying'!

applyTo: aCypressLoader

	aCypressLoader applyRemoval: self
! !

!CypressRemoval methodsFor:'comparing'!

= aPatchOperation
	^(super = aPatchOperation) and: [self definition = aPatchOperation definition]
! !

!CypressRemoval methodsFor:'dependency'!

provisions
	"Answer list of global names defined by this definition"

	^#()
!

requirements
	"Answer list of global names required by this definition"

	^#()
! !

!CypressRemoval methodsFor:'initialization'!

definition: aDefinition

	definition := aDefinition
! !

!CypressRemoval methodsFor:'loading'!

loadClassDefinition
	
	self error: 'inappropriate to send #loadClassDefinition to a removal operation'
!

loadMethodDefinition
	
	self error: 'inappropriate to send #loadMethodDefinition to a removal operation'
!

postLoadDefinition
	
	self error: 'inappropriate to send #postLoadDefinition to a removal operation'
!

unloadDefinition

	self definition unloadDefinition
! !

!CypressRemoval methodsFor:'printing'!

printString

	| str |
	str := WriteStream on: String new.
	str 
		nextPutAll: super printString;
		nextPutAll: ' (';
		nextPutAll: self description;
		nextPutAll: ')'.
	^str contents
! !

!CypressRemoval class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
