"{ Package: 'stx:goodies/cypress' }"

Object subclass:#CypressSnapshot
	instanceVariableNames:'definitions'
	classVariableNames:''
	poolDictionaries:''
	category:'Cypress-Definitions'
!

CypressSnapshot comment:'Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.'
!


!CypressSnapshot class methodsFor:'instance creation'!

definitions: aDefinitions

	^(self new) definitions: aDefinitions
! !

!CypressSnapshot methodsFor:'accessing'!

definitions

	^definitions
!

definitions: aDefinitions

	definitions := aDefinitions
! !

!CypressSnapshot methodsFor:'comparing'!

= other
	^ definitions asArray = other definitions asArray
! !

!CypressSnapshot methodsFor:'enumerating'!

classDefinitions: classBlock methodDefinitions: methodBlock

	self definitions do: [:definition |
		definition classDefinition: classBlock methodDefinition: methodBlock]
! !

!CypressSnapshot methodsFor:'loading'!

updatePackage: aPackage
	CypressLoader updatePackage: aPackage withSnapshot: self
! !

!CypressSnapshot methodsFor:'patching'!

patchRelativeToBase: aSnapshot
	^ CypressPatch fromBase: aSnapshot toTarget: self
! !

!CypressSnapshot class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
